> For the complete documentation index, see [llms.txt](https://docs.lightlink.io/lightlink-protocol/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lightlink.io/lightlink-protocol/building-on-lightlink/boneh-lynn-shacham-signatures-bls.md).

# Boneh-Lynn-Shacham Signatures (BLS)

BLS (Boneh-Lynn-Shacham) is a cryptographic signature scheme that allows a user to verify the authenticity of the signer. This process utilizes bilinear pairings and elliptic curves to generate and aggregate signatures for blocks and transactions. BLS enables the protocol to combine multiple signatures into one while maintaining the traceability of the original signatures.

BLS is used for signing the Replicator nodes' proofs for transactions and blocks. The aggregation of signatures helps save block space, reduces time, and decreases the computational power required to validate the necessary number of proofs. This efficiency allows LightLink to operate with a 500 ms block time and approximately $0.01 per transaction fee.

LightLink supports the most popular curves for BLS, including:

* ecrecover
* sha256hash
* ripemd160hash
* dataCopy
* bigModExp
* bn256AddIstanbul
* bn256ScalarMulIstanbul
* bn256PairingIstanbul
* blake2F

Learn more about [BLS usage in L2s](https://mirror.xyz/0x6afeB3d9E380787e7D0a17Fc3CA764Bb885014FA/D3g-4UPRLkAnug-p6AZYfjgXWo-psaTulyu3SaL35vg).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lightlink.io/lightlink-protocol/building-on-lightlink/boneh-lynn-shacham-signatures-bls.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
